Other B4A v10.7 is available for download

Erel

Administrator
Staff member
Licensed User
Download link: https://www.b4x.com/b4a.html

In the last couple of years, Google made many changes to Android, quite complex, building toolchain. With a few workarounds, it was possible to keep using the older tools, but at this point we have reached their limits.

This update replaces several components of the underlying tools (AAPT2, APKSigner and AAB bundle tool).
It solves all kinds of limitations including:
  • Support for signing scheme v2, which is required when setting targetSdkVersion to 30.
  • Support for building app bundles. This type of package will be required by Google Play, for new apps, later this year.
  • Support for newer versions of SDK resources.
It can also provide some performance improvements.

These are under the hood changes. The behavior should be exactly as before.

Bundles - AAB

There is a new build bundle option:



There is no reason to build bundles (AABs) except for Google Play submissions.
You need to download bundletool.jar and put it in <android sdk>\tools\bin

A new attribute named #SignKeyAlgorithm was added together with a new automatic conditional compilation symbol - AAB, they can be used in cases where the AAB signing key is different than the standard key. This is relevant for new apps:
B4X:
#if AAB
    #SignKeyFile: my-release-key.jks
#SignKeyPassword: xxxxxxx
#SignKeyAlgorithm: -digestalg SHA1 -sigalg SHA256withRSA
#end if
There are some old third party libraries that are not compatible with the new toolchain (DesignSupport for example). If your project depends on such library then you can keep a copy of B4A 10.6. B4A 10.6 is not compatible with targetSdkVersion=30 so it is only a temporary solution.


B4A 10.7 depends on a recent version of the build tools. If you get an error similar to:

Signing package file (debug key). Error
Unsupported option: --v3-signing-enabled. See --help for supported options.

Then you are using an old version of Android SDK and need to upgrade. It is very simple to upgrade the SDK: https://www.b4x.com/b4a.html

Download link: https://www.b4x.com/b4a.html
 
Last edited:

aeric

Well-Known Member
Licensed User
Support for building app bundles. This type of package will be required by Google Play, for new apps, later this year.
This is great! B4A is ready already before Google enforce the new requirement. Unlike some other tools where developers would need to wait for the update and cannot do anything about it.
 

rleiman

Well-Known Member
Licensed User
Thanks for stable version of b4a.
It seems a step by step clear tutorial about how to sign the AAB bundles(for new and existing apps) to be needed.
As a 7-year-old b4a developer, I was personally confused.
I would love to see a tutorial like that as well. ;) Just like you, I'm doing B4A for about 10 years and need that tutorial because I made a salat times and athan app with really large sound files that makes my app size really large. Google Play has rejected it because of the size and they stated it must be made into bundles to be accepted.
 
Last edited:

delgadol

Member
Last night I compiled a new version for an app that is in googleplay, I used the BETA # 3 version, using appcompact compatibility, I have uploaded the version in "apk", and I had no problem, I used admob as well and it works wonderfully.

Any step-by-step tutorial to upload aab files? I did the aab, but when uploading it it told me that it should be registered in google sing. my application is compatible from android 4.0.3 (api 15)

thanks in advence
 

Scantech

Well-Known Member
Licensed User
There are some old third party libraries that are not compatible with the new toolchain (DesignSupport for example).
I use DesignSupport with B4A 10.7 without any issue. Should I avoid version 10.7? I lost my version 10.6. Can I get this copy of 10.6?
 
Last edited:

mcqueccu

Well-Known Member
Licensed User
There are some old third party libraries that are not compatible with the new toolchain (DesignSupport for example).

I use DesignSupport with B4A 10.7 without any issue. Should I avoid version 10.7? I lost my version 10.6. Can I get this copy of 10.6?

If your own is working with 10.7 then you are good to go. Some people using navigation drawer from the design support were having problems hence the recommendation to stick to 10.6. Are you using the drawer?
 

scsjc

Well-Known Member
Licensed User
If your own is working with 10.7 then you are good to go. Some people using navigation drawer from the design support were having problems hence the recommendation to stick to 10.6. Are you using the drawer?
I use the DesignSupport library for some library functions but not for DrawerNavigation, I have tried and it works correctly with version 10.7 on SDK30

I understand that it is only an error that affects only the Drawer Navigation of the DesignSupport library, right?
 

Scantech

Well-Known Member
Licensed User
If your own is working with 10.7 then you are good to go. Some people using navigation drawer from the design support were having problems hence the recommendation to stick to 10.6. Are you using the drawer?
Snackbar and tab only
 
Top